﻿using System;
using System.Data;
using System.Linq;
using System.Windows.Forms;
using Infragistics.UltraChart.Core.Primitives;

namespace ChartWithUserLabels
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            int[] userInput = { 57, 52, 53, 48, 43, 46, 39 };
            int speechInterferenceLine = 5;

            this.ultraChart1.ChartType = Infragistics.UltraChart.Shared.Styles.ChartType.LineChart;
            this.ultraChart1.DataSource = CreateChartData(userInput, speechInterferenceLine);
            this.ultraChart1.DataBind();
        }

        public DataTable CreateChartData(int[] userInput, int speechInterferenceLine)
        {
            DataTable mydata = new DataTable();
            // Define the columns and their names
            mydata.Columns.Add("Series Labels", typeof(string));
            mydata.Columns.Add("63", typeof(int));
            mydata.Columns.Add("125", typeof(int));
            mydata.Columns.Add("250", typeof(int));
            mydata.Columns.Add("500", typeof(int));
            mydata.Columns.Add("1k", typeof(int));
            mydata.Columns.Add("2k", typeof(int));
            mydata.Columns.Add("4k", typeof(int));
            // Add the rows of data
            mydata.Rows.Add(new Object[] { "RC 50", 70, 65, 60, 55, 50, 45, 40 });
            mydata.Rows.Add(new Object[] { "RC 45", 65, 60, 55, 50, 45, 40, 35 });
            mydata.Rows.Add(new Object[] { "RC 40", 60, 55, 50, 45, 40, 35, 30 });
            mydata.Rows.Add(new Object[] { "RC 35", 55, 50, 45, 40, 35, 30, 25 });
            mydata.Rows.Add(new Object[] { "RC 30", 50, 45, 40, 35, 30, 25, 20 });
            mydata.Rows.Add(new Object[] { "RC 25", 45, 40, 35, 30, 25, 20, 15 });
            mydata.Rows.Add(new Object[] { "User Input", userInput[0], userInput[1], userInput[2], userInput[3], userInput[4], userInput[5], userInput[6] });
            mydata.Rows.Add(new Object[] { "Rumble Limit", speechInterferenceLine + 25, speechInterferenceLine + 20, speechInterferenceLine + 15, speechInterferenceLine + 10, null, null, null });
            mydata.Rows.Add(new Object[] { "Hissy Limit", null, null, null, null, speechInterferenceLine + 3, speechInterferenceLine + -2, speechInterferenceLine - 7 });
            mydata.Rows.Add(new Object[] { "Reference Line", speechInterferenceLine + 20, speechInterferenceLine + 15, speechInterferenceLine + 10, speechInterferenceLine + 5, speechInterferenceLine, speechInterferenceLine - 5, speechInterferenceLine - 10 });

            return mydata;
        }

        private void ultraChart1_FillSceneGraph(object sender, Infragistics.UltraChart.Shared.Events.FillSceneGraphEventArgs e)
        {
            // here we are catching all lines except User Input line
            var polyLines = e.SceneGraph.OfType<Polyline>().Where(p => !(p.Row == 6 && p.Column == 6)).ToList();

            if (polyLines.Count == 0)
            {
                return;
            }

            foreach (var polyLine in polyLines)
            {
                foreach (var point in polyLine.points)
                {
                    point.Caps = PCaps.None;
                }
            }
        }
    }
}
